Curve

compute_rhino3d.Curve.GetConicSectionType(thisCurve, multiple=False)

Returns the type of conic section based on the curve’s shape.

Parameters:multiple (bool) – (default False) If True, all parameters are expected as lists of equal length and input will be batch processed
Return type:ConicSectionType
compute_rhino3d.Curve.CreateInterpolatedCurve(points, degree, multiple=False)

Interpolates a sequence of points. Used by InterpCurve Command This routine works best when degree=3.

Parameters:
  • degree (int) – The degree of the curve >=1. Degree must be odd.
  • points (list[rhino3dm.Point3d]) – Points to interpolate (Count must be >= 2)
  • multiple (bool) – (default False) If True, all parameters are expected as lists of equal length and input will be batch processed
Returns:

interpolated curve on success. None on failure.

Return type:

rhino3dm.Curve

compute_rhino3d.Curve.CreateInterpolatedCurve1(points, degree, knots, multiple=False)

Interpolates a sequence of points. Used by InterpCurve Command This routine works best when degree=3.

Parameters:
  • degree (int) – The degree of the curve >=1. Degree must be odd.
  • points (list[rhino3dm.Point3d]) – Points to interpolate. For periodic curves if the final point is a duplicate of the initial point it is ignored. (Count must be >=2)
  • knots (CurveKnotStyle) – Knot-style to use and specifies if the curve should be periodic.
  • multiple (bool) – (default False) If True, all parameters are expected as lists of equal length and input will be batch processed
Returns:

interpolated curve on success. None on failure.

Return type:

rhino3dm.Curve

compute_rhino3d.Curve.CreateInterpolatedCurve2(points, degree, knots, startTangent, endTangent, multiple=False)

Interpolates a sequence of points. Used by InterpCurve Command This routine works best when degree=3.

Parameters:
  • degree (int) – The degree of the curve >=1. Degree must be odd.
  • points (list[rhino3dm.Point3d]) – Points to interpolate. For periodic curves if the final point is a duplicate of the initial point it is ignored. (Count must be >=2)
  • knots (CurveKnotStyle) – Knot-style to use and specifies if the curve should be periodic.
  • startTangent (rhino3dm.Vector3d) – A starting tangent.
  • endTangent (rhino3dm.Vector3d) – An ending tangent.
  • multiple (bool) – (default False) If True, all parameters are expected as lists of equal length and input will be batch processed
Returns:

interpolated curve on success. None on failure.

Return type:

rhino3dm.Curve

compute_rhino3d.Curve.CreateSoftEditCurve(curve, t, delta, length, fixEnds, multiple=False)

Creates a soft edited curve from an exising curve using a smooth field of influence.

Parameters:
  • curve (rhino3dm.Curve) – The curve to soft edit.
  • t (float) – A parameter on the curve to move from. This location on the curve is moved, and the move is smoothly tapered off with increasing distance along the curve from this parameter.
  • delta (rhino3dm.Vector3d) – The direction and magitude, or maximum distance, of the move.
  • length (float) – The distance along the curve from the editing point over which the strength of the editing falls off smoothly.
  • multiple (bool) – (default False) If True, all parameters are expected as lists of equal length and input will be batch processed
Returns:

The soft edited curve if successful. None on failure.

Return type:

rhino3dm.Curve

compute_rhino3d.Curve.CreateFilletCornersCurve(curve, radius, tolerance, angleTolerance, multiple=False)

Rounds the corners of a kinked curve with arcs of a single, specified radius.

Parameters:
  • curve (rhino3dm.Curve) – The curve to fillet.
  • radius (float) – The fillet radius.
  • tolerance (float) – The tolerance. When in doubt, use the document’s model space absolute tolerance.
  • angleTolerance (float) – The angle tolerance in radians. When in doubt, use the document’s model space angle tolerance.
  • multiple (bool) – (default False) If True, all parameters are expected as lists of equal length and input will be batch processed
Returns:

The filleted curve if successful. None on failure.

Return type:

rhino3dm.Curve

compute_rhino3d.Curve.CreateArcBlend(startPt, startDir, endPt, endDir, controlPointLengthRatio, multiple=False)

Creates a polycurve consisting of two tangent arc segments that connect two points and two directions.

Parameters:
  • startPt (rhino3dm.Point3d) – Start of the arc blend curve.
  • startDir (rhino3dm.Vector3d) – Start direction of the arc blend curve.
  • endPt (rhino3dm.Point3d) – End of the arc blend curve.
  • endDir (rhino3dm.Vector3d) – End direction of the arc blend curve.
  • controlPointLengthRatio (float) – The ratio of the control polygon lengths of the two arcs. Note, a value of 1.0 means the control polygon lengths for both arcs will be the same.
  • multiple (bool) – (default False) If True, all parameters are expected as lists of equal length and input will be batch processed
Returns:

The arc blend curve, or None on error.

Return type:

rhino3dm.Curve

compute_rhino3d.Curve.CreateMeanCurve(curveA, curveB, angleToleranceRadians, multiple=False)

Constructs a mean, or average, curve from two curves.

Parameters:
  • curveA (rhino3dm.Curve) – A first curve.
  • curveB (rhino3dm.Curve) – A second curve.
  • angleToleranceRadians (float) – The angle tolerance, in radians, used to match kinks between curves. If you are unsure how to set this parameter, then either use the document’s angle tolerance RhinoDoc.AngleToleranceRadians, or the default value (RhinoMath.UnsetValue)
  • multiple (bool) – (default False) If True, all parameters are expected as lists of equal length and input will be batch processed
Returns:

The average curve, or None on error.

Return type:

rhino3dm.Curve

compute_rhino3d.Curve.CreateMeanCurve1(curveA, curveB, multiple=False)

Constructs a mean, or average, curve from two curves.

Parameters:
  • curveA (rhino3dm.Curve) – A first curve.
  • curveB (rhino3dm.Curve) – A second curve.
  • multiple (bool) – (default False) If True, all parameters are expected as lists of equal length and input will be batch processed
Returns:

The average curve, or None on error.

Return type:

rhino3dm.Curve

compute_rhino3d.Curve.CreateBlendCurve(curveA, curveB, continuity, multiple=False)

Create a Blend curve between two existing curves.

Parameters:
  • curveA (rhino3dm.Curve) – Curve to blend from (blending will occur at curve end point).
  • curveB (rhino3dm.Curve) – Curve to blend to (blending will occur at curve start point).
  • continuity (BlendContinuity) – Continuity of blend.
  • multiple (bool) – (default False) If True, all parameters are expected as lists of equal length and input will be batch processed
Returns:

A curve representing the blend between A and B or None on failure.

Return type:

rhino3dm.Curve

compute_rhino3d.Curve.CreateBlendCurve1(curveA, curveB, continuity, bulgeA, bulgeB, multiple=False)

Create a Blend curve between two existing curves.

Parameters:
  • curveA (rhino3dm.Curve) – Curve to blend from (blending will occur at curve end point).
  • curveB (rhino3dm.Curve) – Curve to blend to (blending will occur at curve start point).
  • continuity (BlendContinuity) – Continuity of blend.
  • bulgeA (float) – Bulge factor at curveA end of blend. Values near 1.0 work best.
  • bulgeB (float) – Bulge factor at curveB end of blend. Values near 1.0 work best.
  • multiple (bool) – (default False) If True, all parameters are expected as lists of equal length and input will be batch processed
Returns:

A curve representing the blend between A and B or None on failure.

Return type:

rhino3dm.Curve

compute_rhino3d.Curve.CreateBlendCurve2(curve0, t0, reverse0, continuity0, curve1, t1, reverse1, continuity1, multiple=False)

Makes a curve blend between 2 curves at the parameters specified with the directions and continuities specified

Parameters:
  • curve0 (rhino3dm.Curve) – First curve to blend from
  • t0 (float) – Parameter on first curve for blend endpoint
  • reverse0 (bool) – If false, the blend will go in the natural direction of the curve. If true, the blend will go in the opposite direction to the curve
  • continuity0 (BlendContinuity) – Continuity for the blend at the start
  • curve1 (rhino3dm.Curve) – Second curve to blend from
  • t1 (float) – Parameter on second curve for blend endpoint
  • reverse1 (bool) – If false, the blend will go in the natural direction of the curve. If true, the blend will go in the opposite direction to the curve
  • continuity1 (BlendContinuity) – Continuity for the blend at the end
  • multiple (bool) – (default False) If True, all parameters are expected as lists of equal length and input will be batch processed
Returns:

The blend curve on success. None on failure

Return type:

rhino3dm.Curve

compute_rhino3d.Curve.CreateTweenCurves(curve0, curve1, numCurves, multiple=False)

Creates curves between two open or closed input curves. Uses the control points of the curves for finding tween curves. That means the first control point of first curve is matched to first control point of the second curve and so on. There is no matching of curves direction. Caller must match input curves direction before calling the function.

Parameters:
  • curve0 (rhino3dm.Curve) – The first, or starting, curve.
  • curve1 (rhino3dm.Curve) – The second, or ending, curve.
  • numCurves (int) – Number of tween curves to create.
  • multiple (bool) – (default False) If True, all parameters are expected as lists of equal length and input will be batch processed
Returns:

An array of joint curves. This array can be empty.

Return type:

rhino3dm.Curve[]

compute_rhino3d.Curve.CreateTweenCurves1(curve0, curve1, numCurves, tolerance, multiple=False)

Creates curves between two open or closed input curves. Uses the control points of the curves for finding tween curves. That means the first control point of first curve is matched to first control point of the second curve and so on. There is no matching of curves direction. Caller must match input curves direction before calling the function.

Parameters:
  • curve0 (rhino3dm.Curve) – The first, or starting, curve.
  • curve1 (rhino3dm.Curve) – The second, or ending, curve.
  • numCurves (int) – Number of tween curves to create.
  • multiple (bool) – (default False) If True, all parameters are expected as lists of equal length and input will be batch processed
Returns:

An array of joint curves. This array can be empty.

Return type:

rhino3dm.Curve[]

compute_rhino3d.Curve.CreateTweenCurvesWithMatching(curve0, curve1, numCurves, multiple=False)

Creates curves between two open or closed input curves. Make the structure of input curves compatible if needed. Refits the input curves to have the same structure. The resulting curves are usually more complex than input unless input curves are compatible and no refit is needed. There is no matching of curves direction. Caller must match input curves direction before calling the function.

Parameters:
  • curve0 (rhino3dm.Curve) – The first, or starting, curve.
  • curve1 (rhino3dm.Curve) – The second, or ending, curve.
  • numCurves (int) – Number of tween curves to create.
  • multiple (bool) – (default False) If True, all parameters are expected as lists of equal length and input will be batch processed
Returns:

An array of joint curves. This array can be empty.

Return type:

rhino3dm.Curve[]

compute_rhino3d.Curve.CreateTweenCurvesWithMatching1(curve0, curve1, numCurves, tolerance, multiple=False)

Creates curves between two open or closed input curves. Make the structure of input curves compatible if needed. Refits the input curves to have the same structure. The resulting curves are usually more complex than input unless input curves are compatible and no refit is needed. There is no matching of curves direction. Caller must match input curves direction before calling the function.

Parameters:
  • curve0 (rhino3dm.Curve) – The first, or starting, curve.
  • curve1 (rhino3dm.Curve) – The second, or ending, curve.
  • numCurves (int) – Number of tween curves to create.
  • multiple (bool) – (default False) If True, all parameters are expected as lists of equal length and input will be batch processed
Returns:

An array of joint curves. This array can be empty.

Return type:

rhino3dm.Curve[]

compute_rhino3d.Curve.CreateTweenCurvesWithSampling(curve0, curve1, numCurves, numSamples, multiple=False)

Creates curves between two open or closed input curves. Use sample points method to make curves compatible. This is how the algorithm workd: Divides the two curves into an equal number of points, finds the midpoint between the corresponding points on the curves and interpolates the tween curve through those points. There is no matching of curves direction. Caller must match input curves direction before calling the function.

Parameters:
  • curve0 (rhino3dm.Curve) – The first, or starting, curve.
  • curve1 (rhino3dm.Curve) – The second, or ending, curve.
  • numCurves (int) – Number of tween curves to create.
  • numSamples (int) – Number of sample points along input curves.
  • multiple (bool) – (default False) If True, all parameters are expected as lists of equal length and input will be batch processed
Returns:

>An array of joint curves. This array can be empty.

Return type:

rhino3dm.Curve[]

compute_rhino3d.Curve.CreateTweenCurvesWithSampling1(curve0, curve1, numCurves, numSamples, tolerance, multiple=False)

Creates curves between two open or closed input curves. Use sample points method to make curves compatible. This is how the algorithm workd: Divides the two curves into an equal number of points, finds the midpoint between the corresponding points on the curves and interpolates the tween curve through those points. There is no matching of curves direction. Caller must match input curves direction before calling the function.

Parameters:
  • curve0 (rhino3dm.Curve) – The first, or starting, curve.
  • curve1 (rhino3dm.Curve) – The second, or ending, curve.
  • numCurves (int) – Number of tween curves to create.
  • numSamples (int) – Number of sample points along input curves.
  • multiple (bool) – (default False) If True, all parameters are expected as lists of equal length and input will be batch processed
Returns:

>An array of joint curves. This array can be empty.

Return type:

rhino3dm.Curve[]

compute_rhino3d.Curve.JoinCurves(inputCurves, multiple=False)

Joins a collection of curve segments together.

Parameters:
  • inputCurves (list[rhino3dm.Curve]) – Curve segments to join.
  • multiple (bool) – (default False) If True, all parameters are expected as lists of equal length and input will be batch processed
Returns:

An array of curves which contains.

Return type:

rhino3dm.Curve[]

compute_rhino3d.Curve.JoinCurves1(inputCurves, joinTolerance, multiple=False)

Joins a collection of curve segments together.

Parameters:
  • inputCurves (list[rhino3dm.Curve]) – An array, a list or any enumerable set of curve segments to join.
  • joinTolerance (float) – Joining tolerance, i.e. the distance between segment end-points that is allowed.
  • multiple (bool) – (default False) If True, all parameters are expected as lists of equal length and input will be batch processed
Returns:

An array of joint curves. This array can be empty.

Return type:

rhino3dm.Curve[]

compute_rhino3d.Curve.JoinCurves2(inputCurves, joinTolerance, preserveDirection, multiple=False)

Joins a collection of curve segments together.

Parameters:
  • inputCurves (list[rhino3dm.Curve]) – An array, a list or any enumerable set of curve segments to join.
  • joinTolerance (float) – Joining tolerance, i.e. the distance between segment end-points that is allowed.
  • preserveDirection (bool) – If true, curve endpoints will be compared to curve startpoints.If false, all start and endpoints will be compared and copies of input curves may be reversed in output.
  • multiple (bool) – (default False) If True, all parameters are expected as lists of equal length and input will be batch processed
Returns:

An array of joint curves. This array can be empty.

Return type:

rhino3dm.Curve[]

compute_rhino3d.Curve.MakeEndsMeet(curveA, adjustStartCurveA, curveB, adjustStartCurveB, multiple=False)

Makes adjustments to the ends of one or both input curves so that they meet at a point.

Parameters:
  • curveA (rhino3dm.Curve) – 1st curve to adjust.
  • adjustStartCurveA (bool) – Which end of the 1st curve to adjust: True is start, False is end.
  • curveB (rhino3dm.Curve) – 2nd curve to adjust.
  • adjustStartCurveB (bool) – which end of the 2nd curve to adjust true==start, false==end.
  • multiple (bool) – (default False) If True, all parameters are expected as lists of equal length and input will be batch processed
Returns:

True on success.

Return type:

bool

compute_rhino3d.Curve.CreateFillet(curve0, curve1, radius, t0Base, t1Base, multiple=False)

Computes the fillet arc for a curve filleting operation.

Parameters:
  • curve0 (rhino3dm.Curve) – First curve to fillet.
  • curve1 (rhino3dm.Curve) – Second curve to fillet.
  • radius (float) – Fillet radius.
  • t0Base (float) – Parameter on curve0 where the fillet ought to start (approximately).
  • t1Base (float) – Parameter on curve1 where the fillet ought to end (approximately).
  • multiple (bool) – (default False) If True, all parameters are expected as lists of equal length and input will be batch processed
Returns:

The fillet arc on success, or Arc.Unset on failure.

Return type:

Arc

compute_rhino3d.Curve.CreateFilletCurves(curve0, point0, curve1, point1, radius, join, trim, arcExtension, tolerance, angleTolerance, multiple=False)

Creates a tangent arc between two curves and trims or extends the curves to the arc.

Parameters:
  • curve0 (rhino3dm.Curve) – The first curve to fillet.
  • point0 (rhino3dm.Point3d) – A point on the first curve that is near the end where the fillet will be created.
  • curve1 (rhino3dm.Curve) – The second curve to fillet.
  • point1 (rhino3dm.Point3d) – A point on the second curve that is near the end where the fillet will be created.
  • radius (float) – The radius of the fillet.
  • join (bool) – Join the output curves.
  • trim (bool) – Trim copies of the input curves to the output fillet curve.
  • arcExtension (bool) – Applies when arcs are filleted but need to be extended to meet the fillet curve or chamfer line. If true, then the arc is extended maintaining its validity. If false, then the arc is extended with a line segment, which is joined to the arc converting it to a polycurve.
  • tolerance (float) – The tolerance, generally the document’s absolute tolerance.
  • multiple (bool) – (default False) If True, all parameters are expected as lists of equal length and input will be batch processed
Returns:

The results of the fillet operation. The number of output curves depends on the input curves and the values of the parameters that were used during the fillet operation. In most cases, the output array will contain either one or three curves, although two curves can be returned if the radius is zero and join = false. For example, if both join and trim = true, then the output curve will be a polycurve containing the fillet curve joined with trimmed copies of the input curves. If join = False and trim = true, then three curves, the fillet curve and trimmed copies of the input curves, will be returned. If both join and trim = false, then just the fillet curve is returned.

Return type:

rhino3dm.Curve[]

compute_rhino3d.Curve.CreateBooleanUnion(curves, multiple=False)

Calculates the boolean union of two or more closed, planar curves. Note, curves must be co-planar.

Parameters:
  • curves (list[rhino3dm.Curve]) – The co-planar curves to union.
  • multiple (bool) – (default False) If True, all parameters are expected as lists of equal length and input will be batch processed
Returns:

Result curves on success, empty array if no union could be calculated.

Return type:

rhino3dm.Curve[]

compute_rhino3d.Curve.CreateBooleanUnion1(curves, tolerance, multiple=False)

Calculates the boolean union of two or more closed, planar curves. Note, curves must be co-planar.

Parameters:
  • curves (list[rhino3dm.Curve]) – The co-planar curves to union.
  • multiple (bool) – (default False) If True, all parameters are expected as lists of equal length and input will be batch processed
Returns:

Result curves on success, empty array if no union could be calculated.

Return type:

rhino3dm.Curve[]

compute_rhino3d.Curve.CreateBooleanIntersection(curveA, curveB, multiple=False)

Calculates the boolean intersection of two closed, planar curves. Note, curves must be co-planar.

Parameters:
  • curveA (rhino3dm.Curve) – The first closed, planar curve.
  • curveB (rhino3dm.Curve) – The second closed, planar curve.
  • multiple (bool) – (default False) If True, all parameters are expected as lists of equal length and input will be batch processed
Returns:

Result curves on success, empty array if no intersection could be calculated.

Return type:

rhino3dm.Curve[]

compute_rhino3d.Curve.CreateBooleanIntersection1(curveA, curveB, tolerance, multiple=False)

Calculates the boolean intersection of two closed, planar curves. Note, curves must be co-planar.

Parameters:
  • curveA (rhino3dm.Curve) – The first closed, planar curve.
  • curveB (rhino3dm.Curve) – The second closed, planar curve.
  • multiple (bool) – (default False) If True, all parameters are expected as lists of equal length and input will be batch processed
Returns:

Result curves on success, empty array if no intersection could be calculated.

Return type:

rhino3dm.Curve[]

compute_rhino3d.Curve.CreateBooleanDifference(curveA, curveB, multiple=False)

Calculates the boolean difference between two closed, planar curves. Note, curves must be co-planar.

Parameters:
  • curveA (rhino3dm.Curve) – The first closed, planar curve.
  • curveB (rhino3dm.Curve) – The second closed, planar curve.
  • multiple (bool) – (default False) If True, all parameters are expected as lists of equal length and input will be batch processed
Returns:

Result curves on success, empty array if no difference could be calculated.

Return type:

rhino3dm.Curve[]

compute_rhino3d.Curve.CreateBooleanDifference1(curveA, curveB, tolerance, multiple=False)

Calculates the boolean difference between two closed, planar curves. Note, curves must be co-planar.

Parameters:
  • curveA (rhino3dm.Curve) – The first closed, planar curve.
  • curveB (rhino3dm.Curve) – The second closed, planar curve.
  • multiple (bool) – (default False) If True, all parameters are expected as lists of equal length and input will be batch processed
Returns:

Result curves on success, empty array if no difference could be calculated.

Return type:

rhino3dm.Curve[]

compute_rhino3d.Curve.CreateBooleanDifference2(curveA, subtractors, multiple=False)

Calculates the boolean difference between a closed planar curve, and a list of closed planar curves. Note, curves must be co-planar.

Parameters:
  • curveA (rhino3dm.Curve) – The first closed, planar curve.
  • subtractors (list[rhino3dm.Curve]) – curves to subtract from the first closed curve.
  • multiple (bool) – (default False) If True, all parameters are expected as lists of equal length and input will be batch processed
Returns:

Result curves on success, empty array if no difference could be calculated.

Return type:

rhino3dm.Curve[]

compute_rhino3d.Curve.CreateBooleanDifference3(curveA, subtractors, tolerance, multiple=False)

Calculates the boolean difference between a closed planar curve, and a list of closed planar curves. Note, curves must be co-planar.

Parameters:
  • curveA (rhino3dm.Curve) – The first closed, planar curve.
  • subtractors (list[rhino3dm.Curve]) – curves to subtract from the first closed curve.
  • multiple (bool) – (default False) If True, all parameters are expected as lists of equal length and input will be batch processed
Returns:

Result curves on success, empty array if no difference could be calculated.

Return type:

rhino3dm.Curve[]

compute_rhino3d.Curve.CreateTextOutlines(text, font, textHeight, textStyle, closeLoops, plane, smallCapsScale, tolerance, multiple=False)

Creates outline curves created from a text string. The functionality is similar to what you find in Rhino’s TextObject command or TextEntity.Explode() in RhinoCommon.

Parameters:
  • text (str) – The text from which to create outline curves.
  • font (str) – The text font.
  • textHeight (float) – The text height.
  • textStyle (int) – The font style. The font style can be any number of the following: 0 - Normal, 1 - Bold, 2 - Italic
  • closeLoops (bool) – Set this value to True when dealing with normal fonts and when you expect closed loops. You may want to set this to False when specifying a single-stroke font where you don’t want closed loops.
  • plane (rhino3dm.Plane) – The plane on which the outline curves will lie.
  • smallCapsScale (float) – Displays lower-case letters as small caps. Set the relative text size to a percentage of the normal text.
  • tolerance (float) – The tolerance for the operation.
  • multiple (bool) – (default False) If True, all parameters are expected as lists of equal length and input will be batch processed
Returns:

An array containing one or more curves if successful.

Return type:

rhino3dm.Curve[]

compute_rhino3d.Curve.CreateCurve2View(curveA, curveB, vectorA, vectorB, tolerance, angleTolerance, multiple=False)

Creates a third curve from two curves that are planar in different construction planes. The new curve looks the same as each of the original curves when viewed in each plane.

Parameters:
  • curveA (rhino3dm.Curve) – The first curve.
  • curveB (rhino3dm.Curve) – The second curve.
  • vectorA (rhino3dm.Vector3d) – A vector defining the normal direction of the plane which the first curve is drawn upon.
  • vectorB (rhino3dm.Vector3d) – A vector defining the normal direction of the plane which the seconf curve is drawn upon.
  • tolerance (float) – The tolerance for the operation.
  • angleTolerance (float) – The angle tolerance for the operation.
  • multiple (bool) – (default False) If True, all parameters are expected as lists of equal length and input will be batch processed
Returns:

An array containing one or more curves if successful.

Return type:

rhino3dm.Curve[]

compute_rhino3d.Curve.DoDirectionsMatch(curveA, curveB, multiple=False)

Determines whether two curves travel more or less in the same direction.

Parameters:
  • curveA (rhino3dm.Curve) – First curve to test.
  • curveB (rhino3dm.Curve) – Second curve to test.
  • multiple (bool) – (default False) If True, all parameters are expected as lists of equal length and input will be batch processed
Returns:

True if both curves more or less point in the same direction, False if they point in the opposite directions.

Return type:

bool

compute_rhino3d.Curve.ProjectToMesh(curve, mesh, direction, tolerance, multiple=False)

Projects a curve to a mesh using a direction and tolerance.

Parameters:
  • curve (rhino3dm.Curve) – A curve.
  • mesh (rhino3dm.Mesh) – A mesh.
  • direction (rhino3dm.Vector3d) – A direction vector.
  • tolerance (float) – A tolerance value.
  • multiple (bool) – (default False) If True, all parameters are expected as lists of equal length and input will be batch processed
Returns:

A curve array.

Return type:

rhino3dm.Curve[]

compute_rhino3d.Curve.ProjectToMesh1(curve, meshes, direction, tolerance, multiple=False)

Projects a curve to a set of meshes using a direction and tolerance.

Parameters:
  • curve (rhino3dm.Curve) – A curve.
  • meshes (list[rhino3dm.Mesh]) – A list, an array or any enumerable of meshes.
  • direction (rhino3dm.Vector3d) – A direction vector.
  • tolerance (float) – A tolerance value.
  • multiple (bool) – (default False) If True, all parameters are expected as lists of equal length and input will be batch processed
Returns:

A curve array.

Return type:

rhino3dm.Curve[]

compute_rhino3d.Curve.ProjectToMesh2(curves, meshes, direction, tolerance, multiple=False)

Projects a curve to a set of meshes using a direction and tolerance.

Parameters:
  • curves (list[rhino3dm.Curve]) – A list, an array or any enumerable of curves.
  • meshes (list[rhino3dm.Mesh]) – A list, an array or any enumerable of meshes.
  • direction (rhino3dm.Vector3d) – A direction vector.
  • tolerance (float) – A tolerance value.
  • multiple (bool) – (default False) If True, all parameters are expected as lists of equal length and input will be batch processed
Returns:

A curve array.

Return type:

rhino3dm.Curve[]

compute_rhino3d.Curve.ProjectToBrep(curve, brep, direction, tolerance, multiple=False)

Projects a Curve onto a Brep along a given direction.

Parameters:
  • curve (rhino3dm.Curve) – Curve to project.
  • brep (rhino3dm.Brep) – Brep to project onto.
  • direction (rhino3dm.Vector3d) – Direction of projection.
  • tolerance (float) – Tolerance to use for projection.
  • multiple (bool) – (default False) If True, all parameters are expected as lists of equal length and input will be batch processed
Returns:

An array of projected curves or empty array if the projection set is empty.

Return type:

rhino3dm.Curve[]

compute_rhino3d.Curve.ProjectToBrep1(curve, breps, direction, tolerance, multiple=False)

Projects a Curve onto a collection of Breps along a given direction.

Parameters:
  • curve (rhino3dm.Curve) – Curve to project.
  • breps (list[rhino3dm.Brep]) – Breps to project onto.
  • direction (rhino3dm.Vector3d) – Direction of projection.
  • tolerance (float) – Tolerance to use for projection.
  • multiple (bool) – (default False) If True, all parameters are expected as lists of equal length and input will be batch processed
Returns:

An array of projected curves or empty array if the projection set is empty.

Return type:

rhino3dm.Curve[]

compute_rhino3d.Curve.ProjectToBrep2(curve, breps, direction, tolerance, multiple=False)

Projects a Curve onto a collection of Breps along a given direction.

Parameters:
  • curve (rhino3dm.Curve) – Curve to project.
  • breps (list[rhino3dm.Brep]) – Breps to project onto.
  • direction (rhino3dm.Vector3d) – Direction of projection.
  • tolerance (float) – Tolerance to use for projection.
  • multiple (bool) – (default False) If True, all parameters are expected as lists of equal length and input will be batch processed
Returns:

An array of projected curves or None if the projection set is empty.

Return type:

rhino3dm.Curve[]

compute_rhino3d.Curve.ProjectToBrep3(curves, breps, direction, tolerance, multiple=False)

Projects a collection of Curves onto a collection of Breps along a given direction.

Parameters:
  • curves (list[rhino3dm.Curve]) – Curves to project.
  • breps (list[rhino3dm.Brep]) – Breps to project onto.
  • direction (rhino3dm.Vector3d) – Direction of projection.
  • tolerance (float) – Tolerance to use for projection.
  • multiple (bool) – (default False) If True, all parameters are expected as lists of equal length and input will be batch processed
Returns:

An array of projected curves or empty array if the projection set is empty.

Return type:

rhino3dm.Curve[]

compute_rhino3d.Curve.ProjectToBrep4(curves, breps, direction, tolerance, multiple=False)

Projects a collection of Curves onto a collection of Breps along a given direction.

Parameters:
  • curves (list[rhino3dm.Curve]) – Curves to project.
  • breps (list[rhino3dm.Brep]) – Breps to project onto.
  • direction (rhino3dm.Vector3d) – Direction of projection.
  • tolerance (float) – Tolerance to use for projection.
  • multiple (bool) – (default False) If True, all parameters are expected as lists of equal length and input will be batch processed
Returns:

An array of projected curves. Array is empty if the projection set is empty.

Return type:

rhino3dm.Curve[]

compute_rhino3d.Curve.ProjectToPlane(curve, plane, multiple=False)

Constructs a curve by projecting an existing curve to a plane.

Parameters:
  • curve (rhino3dm.Curve) – A curve.
  • plane (rhino3dm.Plane) – A plane.
  • multiple (bool) – (default False) If True, all parameters are expected as lists of equal length and input will be batch processed
Returns:

The projected curve on success; None on failure.

Return type:

rhino3dm.Curve

compute_rhino3d.Curve.PullToBrepFace(curve, face, tolerance, multiple=False)

Pull a curve to a BrepFace using closest point projection.

Parameters:
  • curve (rhino3dm.Curve) – Curve to pull.
  • face (rhino3dm.BrepFace) – Brepface that pulls.
  • tolerance (float) – Tolerance to use for pulling.
  • multiple (bool) – (default False) If True, all parameters are expected as lists of equal length and input will be batch processed
Returns:

An array of pulled curves, or an empty array on failure.

Return type:

rhino3dm.Curve[]

compute_rhino3d.Curve.PlanarClosedCurveRelationship(curveA, curveB, testPlane, tolerance, multiple=False)

Determines whether two coplanar simple closed curves are disjoint or intersect; otherwise, if the regions have a containment relationship, discovers which curve encloses the other.

Parameters:
  • curveA (rhino3dm.Curve) – A first curve.
  • curveB (rhino3dm.Curve) – A second curve.
  • testPlane (rhino3dm.Plane) – A plane.
  • tolerance (float) – A tolerance value.
  • multiple (bool) – (default False) If True, all parameters are expected as lists of equal length and input will be batch processed
Returns:

A value indicating the relationship between the first and the second curve.

Return type:

RegionContainment

compute_rhino3d.Curve.PlanarCurveCollision(curveA, curveB, testPlane, tolerance, multiple=False)

Determines if two coplanar curves collide (intersect).

Parameters:
  • curveA (rhino3dm.Curve) – A curve.
  • curveB (rhino3dm.Curve) – Another curve.
  • testPlane (rhino3dm.Plane) – A valid plane containing the curves.
  • tolerance (float) – A tolerance value for intersection.
  • multiple (bool) – (default False) If True, all parameters are expected as lists of equal length and input will be batch processed
Returns:

True if the curves intersect, otherwise false

Return type:

bool

compute_rhino3d.Curve.DuplicateSegments(thisCurve, multiple=False)

Polylines will be exploded into line segments. ExplodeCurves will return the curves in topological order.

Parameters:multiple (bool) – (default False) If True, all parameters are expected as lists of equal length and input will be batch processed
Returns:An array of all the segments that make up this curve.
Return type:rhino3dm.Curve[]
compute_rhino3d.Curve.Smooth(thisCurve, smoothFactor, bXSmooth, bYSmooth, bZSmooth, bFixBoundaries, coordinateSystem, multiple=False)

Smooths a curve by averaging the positions of control points in a specified region.

Parameters:
  • smoothFactor (float) – The smoothing factor, which controls how much control points move towards the average of the neighboring control points.
  • bXSmooth (bool) – When True control points move in X axis direction.
  • bYSmooth (bool) – When True control points move in Y axis direction.
  • bZSmooth (bool) – When True control points move in Z axis direction.
  • bFixBoundaries (bool) – When True the curve ends don’t move.
  • coordinateSystem (SmoothingCoordinateSystem) – The coordinates to determine the direction of the smoothing.
  • multiple (bool) – (default False) If True, all parameters are expected as lists of equal length and input will be batch processed
Returns:

The smoothed curve if successful, None otherwise.

Return type:

rhino3dm.Curve

compute_rhino3d.Curve.Smooth1(thisCurve, smoothFactor, bXSmooth, bYSmooth, bZSmooth, bFixBoundaries, coordinateSystem, plane, multiple=False)

Smooths a curve by averaging the positions of control points in a specified region.

Parameters:
  • smoothFactor (float) – The smoothing factor, which controls how much control points move towards the average of the neighboring control points.
  • bXSmooth (bool) – When True control points move in X axis direction.
  • bYSmooth (bool) – When True control points move in Y axis direction.
  • bZSmooth (bool) – When True control points move in Z axis direction.
  • bFixBoundaries (bool) – When True the curve ends don’t move.
  • coordinateSystem (SmoothingCoordinateSystem) – The coordinates to determine the direction of the smoothing.
  • plane (rhino3dm.Plane) – If SmoothingCoordinateSystem.CPlane specified, then the construction plane.
  • multiple (bool) – (default False) If True, all parameters are expected as lists of equal length and input will be batch processed
Returns:

The smoothed curve if successful, None otherwise.

Return type:

rhino3dm.Curve

compute_rhino3d.Curve.GetLocalPerpPoint(thisCurve, testPoint, seedParmameter, multiple=False)

Search for a location on the curve, near seedParmameter, that is perpendicular to a test point.

Parameters:
  • testPoint (rhino3dm.Point3d) – The test point.
  • seedParmameter (float) – A “seed” parameter on the curve.
  • multiple (bool) – (default False) If True, all parameters are expected as lists of equal length and input will be batch processed
Returns:

True if a solution is found, False otherwise.

Return type:

bool

compute_rhino3d.Curve.GetLocalPerpPoint1(thisCurve, testPoint, seedParmameter, subDomain, multiple=False)

Search for a location on the curve, near seedParmameter, that is perpendicular to a test point.

Parameters:
  • testPoint (rhino3dm.Point3d) – The test point.
  • seedParmameter (float) – A “seed” parameter on the curve.
  • subDomain (rhino3dm.Interval) – The sub-domain of the curve to search.
  • multiple (bool) – (default False) If True, all parameters are expected as lists of equal length and input will be batch processed
Returns:

True if a solution is found, False otherwise.

Return type:

bool

compute_rhino3d.Curve.GetLocalTangentPoint(thisCurve, testPoint, seedParmameter, multiple=False)

Search for a location on the curve, near seedParmameter, that is tangent to a test point.

Parameters:
  • testPoint (rhino3dm.Point3d) – The test point.
  • seedParmameter (float) – A “seed” parameter on the curve.
  • multiple (bool) – (default False) If True, all parameters are expected as lists of equal length and input will be batch processed
Returns:

True if a solution is found, False otherwise.

Return type:

bool

compute_rhino3d.Curve.GetLocalTangentPoint1(thisCurve, testPoint, seedParmameter, subDomain, multiple=False)

Search for a location on the curve, near seedParmameter, that is tangent to a test point.

Parameters:
  • testPoint (rhino3dm.Point3d) – The test point.
  • seedParmameter (float) – A “seed” parameter on the curve.
  • subDomain (rhino3dm.Interval) – The sub-domain of the curve to search.
  • multiple (bool) – (default False) If True, all parameters are expected as lists of equal length and input will be batch processed
Returns:

True if a solution is found, False otherwise.

Return type:

bool

compute_rhino3d.Curve.MakeClosed(thisCurve, tolerance, multiple=False)

If IsClosed, just return true. Otherwise, decide if curve can be closed as follows: Linear curves polylinear curves with 2 segments, Nurbs with 3 or less control points cannot be made closed. Also, if tolerance > 0 and the gap between start and end is larger than tolerance, curve cannot be made closed. Adjust the curve’s endpoint to match its start point.

Parameters:
  • tolerance (float) – If nonzero, and the gap is more than tolerance, curve cannot be made closed.
  • multiple (bool) – (default False) If True, all parameters are expected as lists of equal length and input will be batch processed
Returns:

True on success, False on failure.

Return type:

bool

compute_rhino3d.Curve.LcoalClosestPoint(thisCurve, testPoint, seed, multiple=False)

Find parameter of the point on a curve that is locally closest to the testPoint. The search for a local close point starts at a seed parameter.

Parameters:
  • testPoint (rhino3dm.Point3d) – A point to test against.
  • seed (float) – The seed parameter.
  • multiple (bool) – (default False) If True, all parameters are expected as lists of equal length and input will be batch processed
Returns:

True if the search is successful, False if the search fails.

Return type:

bool

compute_rhino3d.Curve.ClosestPoint(thisCurve, testPoint, multiple=False)

Finds parameter of the point on a curve that is closest to testPoint. If the maximumDistance parameter is > 0, then only points whose distance to the given point is <= maximumDistance will be returned. Using a positive value of maximumDistance can substantially speed up the search.

Parameters:
  • testPoint (rhino3dm.Point3d) – Point to search from.
  • multiple (bool) – (default False) If True, all parameters are expected as lists of equal length and input will be batch processed
Returns:

True on success, False on failure.

Return type:

bool

compute_rhino3d.Curve.ClosestPoint1(thisCurve, testPoint, maximumDistance, multiple=False)

Finds the parameter of the point on a curve that is closest to testPoint. If the maximumDistance parameter is > 0, then only points whose distance to the given point is <= maximumDistance will be returned. Using a positive value of maximumDistance can substantially speed up the search.

Parameters:
  • testPoint (rhino3dm.Point3d) – Point to project.
  • maximumDistance (float) – The maximum allowed distance. Past this distance, the search is given up and False is returned.Use 0 to turn off this parameter.
  • multiple (bool) – (default False) If True, all parameters are expected as lists of equal length and input will be batch processed
Returns:

True on success, False on failure.

Return type:

bool

compute_rhino3d.Curve.ClosestPoints(thisCurve, otherCurve, multiple=False)

Gets closest points between this and another curves.

Parameters:
  • otherCurve (rhino3dm.Curve) – The other curve.
  • multiple (bool) – (default False) If True, all parameters are expected as lists of equal length and input will be batch processed
Returns:

True on success; False on error.

Return type:

bool

compute_rhino3d.Curve.Contains(thisCurve, testPoint, multiple=False)

Computes the relationship between a point and a closed curve region. This curve must be closed or the return value will be Unset. Both curve and point are projected to the World XY plane.

Parameters:
  • testPoint (rhino3dm.Point3d) – Point to test.
  • multiple (bool) – (default False) If True, all parameters are expected as lists of equal length and input will be batch processed
Returns:

Relationship between point and curve region.

Return type:

PointContainment

compute_rhino3d.Curve.Contains1(thisCurve, testPoint, plane, multiple=False)

Computes the relationship between a point and a closed curve region. This curve must be closed or the return value will be Unset.

Parameters:
  • testPoint (rhino3dm.Point3d) – Point to test.
  • plane (rhino3dm.Plane) – Plane in in which to compare point and region.
  • multiple (bool) – (default False) If True, all parameters are expected as lists of equal length and input will be batch processed
Returns:

Relationship between point and curve region.

Return type:

PointContainment

compute_rhino3d.Curve.Contains2(thisCurve, testPoint, plane, tolerance, multiple=False)

Computes the relationship between a point and a closed curve region. This curve must be closed or the return value will be Unset.

Parameters:
  • testPoint (rhino3dm.Point3d) – Point to test.
  • plane (rhino3dm.Plane) – Plane in in which to compare point and region.
  • tolerance (float) – Tolerance to use during comparison.
  • multiple (bool) – (default False) If True, all parameters are expected as lists of equal length and input will be batch processed
Returns:

Relationship between point and curve region.

Return type:

PointContainment

compute_rhino3d.Curve.ExtremeParameters(thisCurve, direction, multiple=False)

Returns the parameter values of all local extrema. Parameter values are in increasing order so consecutive extrema define an interval on which each component of the curve is monotone. Note, non-periodic curves always return the end points.

Parameters:
  • direction (rhino3dm.Vector3d) – The direction in which to perform the calculation.
  • multiple (bool) – (default False) If True, all parameters are expected as lists of equal length and input will be batch processed
Returns:

The parameter values of all local extrema.

Return type:

float[]

compute_rhino3d.Curve.CreatePeriodicCurve(curve, multiple=False)

Removes kinks from a curve. Periodic curves deform smoothly without kinks.

Parameters:
  • curve (rhino3dm.Curve) – The curve to make periodic. Curve must have degree >= 2.
  • multiple (bool) – (default False) If True, all parameters are expected as lists of equal length and input will be batch processed
Returns:

The resulting curve if successful, None otherwise.

Return type:

rhino3dm.Curve

compute_rhino3d.Curve.CreatePeriodicCurve1(curve, smooth, multiple=False)

Removes kinks from a curve. Periodic curves deform smoothly without kinks.

Parameters:
  • curve (rhino3dm.Curve) – The curve to make periodic. Curve must have degree >= 2.
  • smooth (bool) – If true, smooths any kinks in the curve and moves control points to make a smooth curve. If false, control point locations are not changed or changed minimally (only one point may move) and only the knot vector is altered.
  • multiple (bool) – (default False) If True, all parameters are expected as lists of equal length and input will be batch processed
Returns:

The resulting curve if successful, None otherwise.

Return type:

rhino3dm.Curve

compute_rhino3d.Curve.PointAtLength(thisCurve, length, multiple=False)

Gets a point at a certain length along the curve. The length must be non-negative and less than or equal to the length of the curve. Lengths will not be wrapped when the curve is closed or periodic.

Parameters:
  • length (float) – Length along the curve between the start point and the returned point.
  • multiple (bool) – (default False) If True, all parameters are expected as lists of equal length and input will be batch processed
Returns:

Point on the curve at the specified length from the start point or Poin3d.Unset on failure.

Return type:

rhino3dm.Point3d

compute_rhino3d.Curve.PointAtNormalizedLength(thisCurve, length, multiple=False)

Gets a point at a certain normalized length along the curve. The length must be between or including 0.0 and 1.0, where 0.0 equals the start of the curve and 1.0 equals the end of the curve.

Parameters:
  • length (float) – Normalized length along the curve between the start point and the returned point.
  • multiple (bool) – (default False) If True, all parameters are expected as lists of equal length and input will be batch processed
Returns:

Point on the curve at the specified normalized length from the start point or Poin3d.Unset on failure.

Return type:

rhino3dm.Point3d

compute_rhino3d.Curve.PerpendicularFrameAt(thisCurve, t, multiple=False)

Return a 3d frame at a parameter. This is slightly different than FrameAt in that the frame is computed in a way so there is minimal rotation from one frame to the next.

Parameters:
  • t (float) – Evaluation parameter.
  • multiple (bool) – (default False) If True, all parameters are expected as lists of equal length and input will be batch processed
Returns:

True on success, False on failure.

Return type:

bool

compute_rhino3d.Curve.GetPerpendicularFrames(thisCurve, parameters, multiple=False)

Gets a collection of perpendicular frames along the curve. Perpendicular frames are also known as ‘Zero-twisting frames’ and they minimize rotation from one frame to the next.

Parameters:
  • parameters (list[float]) – A collection of strictly increasing curve parameters to place perpendicular frames on.
  • multiple (bool) – (default False) If True, all parameters are expected as lists of equal length and input will be batch processed
Returns:

An array of perpendicular frames on success or None on failure.

Return type:

rhino3dm.Plane[]

compute_rhino3d.Curve.GetLength(thisCurve, multiple=False)

Gets the length of the curve with a fractional tolerance of 1.0e-8.

Parameters:multiple (bool) – (default False) If True, all parameters are expected as lists of equal length and input will be batch processed
Returns:The length of the curve on success, or zero on failure.
Return type:float
compute_rhino3d.Curve.GetLength1(thisCurve, fractionalTolerance, multiple=False)

Get the length of the curve.

Parameters:
  • fractionalTolerance (float) – Desired fractional precision. fabs((“exact” length from start to t) - arc_length)/arc_length <= fractionalTolerance.
  • multiple (bool) – (default False) If True, all parameters are expected as lists of equal length and input will be batch processed
Returns:

The length of the curve on success, or zero on failure.

Return type:

float

compute_rhino3d.Curve.GetLength2(thisCurve, subdomain, multiple=False)

Get the length of a sub-section of the curve with a fractional tolerance of 1e-8.

Parameters:
  • subdomain (rhino3dm.Interval) – The calculation is performed on the specified sub-domain of the curve (must be non-decreasing).
  • multiple (bool) – (default False) If True, all parameters are expected as lists of equal length and input will be batch processed
Returns:

The length of the sub-curve on success, or zero on failure.

Return type:

float

compute_rhino3d.Curve.GetLength3(thisCurve, fractionalTolerance, subdomain, multiple=False)

Get the length of a sub-section of the curve.

Parameters:
  • fractionalTolerance (float) – Desired fractional precision. fabs((“exact” length from start to t) - arc_length)/arc_length <= fractionalTolerance.
  • subdomain (rhino3dm.Interval) – The calculation is performed on the specified sub-domain of the curve (must be non-decreasing).
  • multiple (bool) – (default False) If True, all parameters are expected as lists of equal length and input will be batch processed
Returns:

The length of the sub-curve on success, or zero on failure.

Return type:

float

compute_rhino3d.Curve.IsShort(thisCurve, tolerance, multiple=False)

Used to quickly find short curves.

Parameters:
  • tolerance (float) – Length threshold value for “shortness”.
  • multiple (bool) – (default False) If True, all parameters are expected as lists of equal length and input will be batch processed
Returns:

True if the length of the curve is <= tolerance.

Return type:

bool

compute_rhino3d.Curve.IsShort1(thisCurve, tolerance, subdomain, multiple=False)

Used to quickly find short curves.

Parameters:
  • tolerance (float) – Length threshold value for “shortness”.
  • subdomain (rhino3dm.Interval) – The test is performed on the interval that is the intersection of subdomain with Domain()
  • multiple (bool) – (default False) If True, all parameters are expected as lists of equal length and input will be batch processed
Returns:

True if the length of the curve is <= tolerance.

Return type:

bool

compute_rhino3d.Curve.RemoveShortSegments(thisCurve, tolerance, multiple=False)

Looks for segments that are shorter than tolerance that can be removed. Does not change the domain, but it will change the relative parameterization.

Parameters:
  • tolerance (float) – Tolerance which defines “short” segments.
  • multiple (bool) – (default False) If True, all parameters are expected as lists of equal length and input will be batch processed
Returns:

True if removable short segments were found. False if no removable short segments were found.

Return type:

bool

compute_rhino3d.Curve.LengthParameter(thisCurve, segmentLength, multiple=False)

Gets the parameter along the curve which coincides with a given length along the curve. A fractional tolerance of 1e-8 is used in this version of the function.

Parameters:
  • segmentLength (float) – Length of segment to measure. Must be less than or equal to the length of the curve.
  • multiple (bool) – (default False) If True, all parameters are expected as lists of equal length and input will be batch processed
Returns:

True on success, False on failure.

Return type:

bool

compute_rhino3d.Curve.LengthParameter1(thisCurve, segmentLength, fractionalTolerance, multiple=False)

Gets the parameter along the curve which coincides with a given length along the curve.

Parameters:
  • segmentLength (float) – Length of segment to measure. Must be less than or equal to the length of the curve.
  • fractionalTolerance (float) – Desired fractional precision. fabs((“exact” length from start to t) - arc_length)/arc_length <= fractionalTolerance.
  • multiple (bool) – (default False) If True, all parameters are expected as lists of equal length and input will be batch processed
Returns:

True on success, False on failure.

Return type:

bool

compute_rhino3d.Curve.LengthParameter2(thisCurve, segmentLength, subdomain, multiple=False)

Gets the parameter along the curve which coincides with a given length along the curve. A fractional tolerance of 1e-8 is used in this version of the function.

Parameters:
  • segmentLength (float) – Length of segment to measure. Must be less than or equal to the length of the subdomain.
  • subdomain (rhino3dm.Interval) – The calculation is performed on the specified sub-domain of the curve rather than the whole curve.
  • multiple (bool) – (default False) If True, all parameters are expected as lists of equal length and input will be batch processed
Returns:

True on success, False on failure.

Return type:

bool

compute_rhino3d.Curve.LengthParameter3(thisCurve, segmentLength, fractionalTolerance, subdomain, multiple=False)

Gets the parameter along the curve which coincides with a given length along the curve.

Parameters:
  • segmentLength (float) – Length of segment to measure. Must be less than or equal to the length of the subdomain.
  • fractionalTolerance (float) – Desired fractional precision. fabs((“exact” length from start to t) - arc_length)/arc_length <= fractionalTolerance.
  • subdomain (rhino3dm.Interval) – The calculation is performed on the specified sub-domain of the curve rather than the whole curve.
  • multiple (bool) – (default False) If True, all parameters are expected as lists of equal length and input will be batch processed
Returns:

True on success, False on failure.

Return type:

bool

compute_rhino3d.Curve.NormalizedLengthParameter(thisCurve, s, multiple=False)

Input the parameter of the point on the curve that is a prescribed arc length from the start of the curve. A fractional tolerance of 1e-8 is used in this version of the function.

Parameters:
  • s (float) – Normalized arc length parameter. E.g., 0 = start of curve, 1/2 = midpoint of curve, 1 = end of curve.
  • multiple (bool) – (default False) If True, all parameters are expected as lists of equal length and input will be batch processed
Returns:

True on success, False on failure.

Return type:

bool

compute_rhino3d.Curve.NormalizedLengthParameter1(thisCurve, s, fractionalTolerance, multiple=False)

Input the parameter of the point on the curve that is a prescribed arc length from the start of the curve.

Parameters:
  • s (float) – Normalized arc length parameter. E.g., 0 = start of curve, 1/2 = midpoint of curve, 1 = end of curve.
  • fractionalTolerance (float) – Desired fractional precision. fabs((“exact” length from start to t) - arc_length)/arc_length <= fractionalTolerance.
  • multiple (bool) – (default False) If True, all parameters are expected as lists of equal length and input will be batch processed
Returns:

True on success, False on failure.

Return type:

bool

compute_rhino3d.Curve.NormalizedLengthParameter2(thisCurve, s, subdomain, multiple=False)

Input the parameter of the point on the curve that is a prescribed arc length from the start of the curve. A fractional tolerance of 1e-8 is used in this version of the function.

Parameters:
  • s (float) – Normalized arc length parameter. E.g., 0 = start of curve, 1/2 = midpoint of curve, 1 = end of curve.
  • subdomain (rhino3dm.Interval) – The calculation is performed on the specified sub-domain of the curve.
  • multiple (bool) – (default False) If True, all parameters are expected as lists of equal length and input will be batch processed
Returns:

True on success, False on failure.

Return type:

bool

compute_rhino3d.Curve.NormalizedLengthParameter3(thisCurve, s, fractionalTolerance, subdomain, multiple=False)

Input the parameter of the point on the curve that is a prescribed arc length from the start of the curve.

Parameters:
  • s (float) – Normalized arc length parameter. E.g., 0 = start of curve, 1/2 = midpoint of curve, 1 = end of curve.
  • fractionalTolerance (float) – Desired fractional precision. fabs((“exact” length from start to t) - arc_length)/arc_length <= fractionalTolerance.
  • subdomain (rhino3dm.Interval) – The calculation is performed on the specified sub-domain of the curve.
  • multiple (bool) – (default False) If True, all parameters are expected as lists of equal length and input will be batch processed
Returns:

True on success, False on failure.

Return type:

bool

compute_rhino3d.Curve.NormalizedLengthParameters(thisCurve, s, absoluteTolerance, multiple=False)

Input the parameter of the point on the curve that is a prescribed arc length from the start of the curve. A fractional tolerance of 1e-8 is used in this version of the function.

Parameters:
  • s (float[]) – Array of normalized arc length parameters. E.g., 0 = start of curve, 1/2 = midpoint of curve, 1 = end of curve.
  • absoluteTolerance (float) – If absoluteTolerance > 0, then the difference between (s[i+1]-s[i])*curve_length and the length of the curve segment from t[i] to t[i+1] will be <= absoluteTolerance.
  • multiple (bool) – (default False) If True, all parameters are expected as lists of equal length and input will be batch processed
Returns:

If successful, array of curve parameters such that the length of the curve from its start to t[i] is s[i]*curve_length. Null on failure.

Return type:

float[]

compute_rhino3d.Curve.NormalizedLengthParameters1(thisCurve, s, absoluteTolerance, fractionalTolerance, multiple=False)

Input the parameter of the point on the curve that is a prescribed arc length from the start of the curve.

Parameters:
  • s (float[]) – Array of normalized arc length parameters. E.g., 0 = start of curve, 1/2 = midpoint of curve, 1 = end of curve.
  • absoluteTolerance (float) – If absoluteTolerance > 0, then the difference between (s[i+1]-s[i])*curve_length and the length of the curve segment from t[i] to t[i+1] will be <= absoluteTolerance.
  • fractionalTolerance (float) – Desired fractional precision for each segment. fabs(“true” length - actual length)/(actual length) <= fractionalTolerance.
  • multiple (bool) – (default False) If True, all parameters are expected as lists of equal length and input will be batch processed
Returns:

If successful, array of curve parameters such that the length of the curve from its start to t[i] is s[i]*curve_length. Null on failure.

Return type:

float[]

compute_rhino3d.Curve.NormalizedLengthParameters2(thisCurve, s, absoluteTolerance, subdomain, multiple=False)

Input the parameter of the point on the curve that is a prescribed arc length from the start of the curve. A fractional tolerance of 1e-8 is used in this version of the function.

Parameters:
  • s (float[]) – Array of normalized arc length parameters. E.g., 0 = start of curve, 1/2 = midpoint of curve, 1 = end of curve.
  • absoluteTolerance (float) – If absoluteTolerance > 0, then the difference between (s[i+1]-s[i])*curve_length and the length of the curve segment from t[i] to t[i+1] will be <= absoluteTolerance.
  • subdomain (rhino3dm.Interval) – The calculation is performed on the specified sub-domain of the curve. A 0.0 s value corresponds to subdomain->Min() and a 1.0 s value corresponds to subdomain->Max().
  • multiple (bool) – (default False) If True, all parameters are expected as lists of equal length and input will be batch processed
Returns:

If successful, array of curve parameters such that the length of the curve from its start to t[i] is s[i]*curve_length. Null on failure.

Return type:

float[]

compute_rhino3d.Curve.NormalizedLengthParameters3(thisCurve, s, absoluteTolerance, fractionalTolerance, subdomain, multiple=False)

Input the parameter of the point on the curve that is a prescribed arc length from the start of the curve.

Parameters:
  • s (float[]) – Array of normalized arc length parameters. E.g., 0 = start of curve, 1/2 = midpoint of curve, 1 = end of curve.
  • absoluteTolerance (float) – If absoluteTolerance > 0, then the difference between (s[i+1]-s[i])*curve_length and the length of the curve segment from t[i] to t[i+1] will be <= absoluteTolerance.
  • fractionalTolerance (float) – Desired fractional precision for each segment. fabs(“true” length - actual length)/(actual length) <= fractionalTolerance.
  • subdomain (rhino3dm.Interval) – The calculation is performed on the specified sub-domain of the curve. A 0.0 s value corresponds to subdomain->Min() and a 1.0 s value corresponds to subdomain->Max().
  • multiple (bool) – (default False) If True, all parameters are expected as lists of equal length and input will be batch processed
Returns:

If successful, array of curve parameters such that the length of the curve from its start to t[i] is s[i]*curve_length. Null on failure.

Return type:

float[]

compute_rhino3d.Curve.DivideByCount(thisCurve, segmentCount, includeEnds, multiple=False)

Divide the curve into a number of equal-length segments.

Parameters:
  • segmentCount (int) – Segment count. Note that the number of division points may differ from the segment count.
  • includeEnds (bool) – If true, then the point at the start of the first division segment is returned.
  • multiple (bool) – (default False) If True, all parameters are expected as lists of equal length and input will be batch processed
Returns:

List of curve parameters at the division points on success, None on failure.

Return type:

float[]

compute_rhino3d.Curve.DivideByCount1(thisCurve, segmentCount, includeEnds, multiple=False)

Divide the curve into a number of equal-length segments.

Parameters:
  • segmentCount (int) – Segment count. Note that the number of division points may differ from the segment count.
  • includeEnds (bool) – If true, then the point at the start of the first division segment is returned.
  • multiple (bool) – (default False) If True, all parameters are expected as lists of equal length and input will be batch processed
Returns:

Array containing division curve parameters on success, None on failure.

Return type:

float[]

compute_rhino3d.Curve.DivideByLength(thisCurve, segmentLength, includeEnds, multiple=False)

Divide the curve into specific length segments.

Parameters:
  • segmentLength (float) – The length of each and every segment (except potentially the last one).
  • includeEnds (bool) – If true, then the point at the start of the first division segment is returned.
  • multiple (bool) – (default False) If True, all parameters are expected as lists of equal length and input will be batch processed
Returns:

Array containing division curve parameters if successful, None on failure.

Return type:

float[]

compute_rhino3d.Curve.DivideByLength1(thisCurve, segmentLength, includeEnds, reverse, multiple=False)

Divide the curve into specific length segments.

Parameters:
  • segmentLength (float) – The length of each and every segment (except potentially the last one).
  • includeEnds (bool) – If true, then the point at the start of the first division segment is returned.
  • reverse (bool) – If true, then the divisions start from the end of the curve.
  • multiple (bool) – (default False) If True, all parameters are expected as lists of equal length and input will be batch processed
Returns:

Array containing division curve parameters if successful, None on failure.

Return type:

float[]

compute_rhino3d.Curve.DivideByLength2(thisCurve, segmentLength, includeEnds, multiple=False)

Divide the curve into specific length segments.

Parameters:
  • segmentLength (float) – The length of each and every segment (except potentially the last one).
  • includeEnds (bool) – If true, then the point at the start of the first division segment is returned.
  • multiple (bool) – (default False) If True, all parameters are expected as lists of equal length and input will be batch processed
Returns:

Array containing division curve parameters if successful, None on failure.

Return type:

float[]

compute_rhino3d.Curve.DivideByLength3(thisCurve, segmentLength, includeEnds, reverse, multiple=False)

Divide the curve into specific length segments.

Parameters:
  • segmentLength (float) – The length of each and every segment (except potentially the last one).
  • includeEnds (bool) – If true, then the point at the start of the first division segment is returned.
  • reverse (bool) – If true, then the divisions start from the end of the curve.
  • multiple (bool) – (default False) If True, all parameters are expected as lists of equal length and input will be batch processed
Returns:

Array containing division curve parameters if successful, None on failure.

Return type:

float[]

compute_rhino3d.Curve.DivideEquidistant(thisCurve, distance, multiple=False)

Calculates 3d points on a curve where the linear distance between the points is equal.

Parameters:
  • distance (float) – The distance betwen division points.
  • multiple (bool) – (default False) If True, all parameters are expected as lists of equal length and input will be batch processed
Returns:

An array of equidistant points, or None on error.

Return type:

rhino3dm.Point3d[]

compute_rhino3d.Curve.DivideAsContour(thisCurve, contourStart, contourEnd, interval, multiple=False)

Divides this curve at fixed steps along a defined contour line.

Parameters:
  • contourStart (rhino3dm.Point3d) – The start of the contouring line.
  • contourEnd (rhino3dm.Point3d) – The end of the contouring line.
  • interval (float) – A distance to measure on the contouring axis.
  • multiple (bool) – (default False) If True, all parameters are expected as lists of equal length and input will be batch processed
Returns:

An array of points; or None on error.

Return type:

rhino3dm.Point3d[]

compute_rhino3d.Curve.Trim(thisCurve, side, length, multiple=False)

Shortens a curve by a given length

Parameters:multiple (bool) – (default False) If True, all parameters are expected as lists of equal length and input will be batch processed
Returns:Trimmed curve if successful, None on failure.
Return type:rhino3dm.Curve
compute_rhino3d.Curve.Split(thisCurve, cutter, tolerance, multiple=False)

Splits a curve into pieces using a polysurface.

Parameters:
  • cutter (rhino3dm.Brep) – A cutting surface or polysurface.
  • tolerance (float) – A tolerance for computing intersections.
  • multiple (bool) – (default False) If True, all parameters are expected as lists of equal length and input will be batch processed
Returns:

An array of curves. This array can be empty.

Return type:

rhino3dm.Curve[]

compute_rhino3d.Curve.Split1(thisCurve, cutter, tolerance, angleToleranceRadians, multiple=False)

Splits a curve into pieces using a polysurface.

Parameters:
  • cutter (rhino3dm.Brep) – A cutting surface or polysurface.
  • tolerance (float) – A tolerance for computing intersections.
  • multiple (bool) – (default False) If True, all parameters are expected as lists of equal length and input will be batch processed
Returns:

An array of curves. This array can be empty.

Return type:

rhino3dm.Curve[]

compute_rhino3d.Curve.Split2(thisCurve, cutter, tolerance, multiple=False)

Splits a curve into pieces using a surface.

Parameters:
  • cutter (rhino3dm.Surface) – A cutting surface or polysurface.
  • tolerance (float) – A tolerance for computing intersections.
  • multiple (bool) – (default False) If True, all parameters are expected as lists of equal length and input will be batch processed
Returns:

An array of curves. This array can be empty.

Return type:

rhino3dm.Curve[]

compute_rhino3d.Curve.Split3(thisCurve, cutter, tolerance, angleToleranceRadians, multiple=False)

Splits a curve into pieces using a surface.

Parameters:
  • cutter (rhino3dm.Surface) – A cutting surface or polysurface.
  • tolerance (float) – A tolerance for computing intersections.
  • multiple (bool) – (default False) If True, all parameters are expected as lists of equal length and input will be batch processed
Returns:

An array of curves. This array can be empty.

Return type:

rhino3dm.Curve[]

compute_rhino3d.Curve.Extend(thisCurve, t0, t1, multiple=False)

Where possible, analytically extends curve to include the given domain. This will not work on closed curves. The original curve will be identical to the restriction of the resulting curve to the original curve domain.

Parameters:
  • t0 (float) – Start of extension domain, if the start is not inside the Domain of this curve, an attempt will be made to extend the curve.
  • t1 (float) – End of extension domain, if the end is not inside the Domain of this curve, an attempt will be made to extend the curve.
  • multiple (bool) – (default False) If True, all parameters are expected as lists of equal length and input will be batch processed
Returns:

Extended curve on success, None on failure.

Return type:

rhino3dm.Curve

compute_rhino3d.Curve.Extend1(thisCurve, domain, multiple=False)

Where possible, analytically extends curve to include the given domain. This will not work on closed curves. The original curve will be identical to the restriction of the resulting curve to the original curve domain.

Parameters:
  • domain (rhino3dm.Interval) – Extension domain.
  • multiple (bool) – (default False) If True, all parameters are expected as lists of equal length and input will be batch processed
Returns:

Extended curve on success, None on failure.

Return type:

rhino3dm.Curve

compute_rhino3d.Curve.Extend2(thisCurve, side, length, style, multiple=False)

Extends a curve by a specific length.

Parameters:
  • side (CurveEnd) – Curve end to extend.
  • length (float) – Length to add to the curve end.
  • style (CurveExtensionStyle) – Extension style.
  • multiple (bool) – (default False) If True, all parameters are expected as lists of equal length and input will be batch processed
Returns:

A curve with extended ends or None on failure.

Return type:

rhino3dm.Curve

compute_rhino3d.Curve.Extend3(thisCurve, side, style, geometry, multiple=False)

Extends a curve until it intersects a collection of objects.

Parameters:
  • side (CurveEnd) – The end of the curve to extend.
  • style (CurveExtensionStyle) – The style or type of extension to use.
  • geometry (System.Collections.Generic.IEnumerable<GeometryBase>) – A collection of objects. Allowable object types are Curve, Surface, Brep.
  • multiple (bool) – (default False) If True, all parameters are expected as lists of equal length and input will be batch processed
Returns:

New extended curve result on success, None on failure.

Return type:

rhino3dm.Curve

compute_rhino3d.Curve.Extend4(thisCurve, side, style, endPoint, multiple=False)

Extends a curve to a point.

Parameters:
  • side (CurveEnd) – The end of the curve to extend.
  • style (CurveExtensionStyle) – The style or type of extension to use.
  • endPoint (rhino3dm.Point3d) – A new end point.
  • multiple (bool) – (default False) If True, all parameters are expected as lists of equal length and input will be batch processed
Returns:

New extended curve result on success, None on failure.

Return type:

rhino3dm.Curve

compute_rhino3d.Curve.ExtendOnSurface(thisCurve, side, surface, multiple=False)

Extends a curve on a surface.

Parameters:
  • side (CurveEnd) – The end of the curve to extend.
  • surface (rhino3dm.Surface) – Surface that contains the curve.
  • multiple (bool) – (default False) If True, all parameters are expected as lists of equal length and input will be batch processed
Returns:

New extended curve result on success, None on failure.

Return type:

rhino3dm.Curve

compute_rhino3d.Curve.ExtendOnSurface1(thisCurve, side, face, multiple=False)

Extends a curve on a surface.

Parameters:
  • side (CurveEnd) – The end of the curve to extend.
  • face (rhino3dm.BrepFace) – BrepFace that contains the curve.
  • multiple (bool) – (default False) If True, all parameters are expected as lists of equal length and input will be batch processed
Returns:

New extended curve result on success, None on failure.

Return type:

rhino3dm.Curve

compute_rhino3d.Curve.ExtendByLine(thisCurve, side, geometry, multiple=False)

Extends a curve by a line until it intersects a collection of objects.

Parameters:
  • side (CurveEnd) – The end of the curve to extend.
  • geometry (System.Collections.Generic.IEnumerable<GeometryBase>) – A collection of objects. Allowable object types are Curve, Surface, Brep.
  • multiple (bool) – (default False) If True, all parameters are expected as lists of equal length and input will be batch processed
Returns:

New extended curve result on success, None on failure.

Return type:

rhino3dm.Curve

compute_rhino3d.Curve.ExtendByArc(thisCurve, side, geometry, multiple=False)

Extends a curve by an Arc until it intersects a collection of objects.

Parameters:
  • side (CurveEnd) – The end of the curve to extend.
  • geometry (System.Collections.Generic.IEnumerable<GeometryBase>) – A collection of objects. Allowable object types are Curve, Surface, Brep.
  • multiple (bool) – (default False) If True, all parameters are expected as lists of equal length and input will be batch processed
Returns:

New extended curve result on success, None on failure.

Return type:

rhino3dm.Curve

compute_rhino3d.Curve.Simplify(thisCurve, options, distanceTolerance, angleToleranceRadians, multiple=False)

Returns a geometrically equivalent PolyCurve. The PolyCurve has the following properties 1. All the PolyCurve segments are LineCurve, PolylineCurve, ArcCurve, or NurbsCurve.

  1. The Nurbs Curves segments do not have fully multiple interior knots.
  2. Rational Nurbs curves do not have constant weights.

4. Any segment for which IsLinear() or IsArc() is True is a Line, Polyline segment, or an Arc.

  1. Adjacent Colinear or Cocircular segments are combined.

6. Segments that meet with G1-continuity have there ends tuned up so that they meet with G1-continuity to within machine precision.

Parameters:
  • options (CurveSimplifyOptions) – Simplification options.
  • distanceTolerance (float) – A distance tolerance for the simplification.
  • angleToleranceRadians (float) – An angle tolerance for the simplification.
  • multiple (bool) – (default False) If True, all parameters are expected as lists of equal length and input will be batch processed
Returns:

New simplified curve on success, None on failure.

Return type:

rhino3dm.Curve

compute_rhino3d.Curve.SimplifyEnd(thisCurve, end, options, distanceTolerance, angleToleranceRadians, multiple=False)

Same as SimplifyCurve, but simplifies only the last two segments at “side” end.

Parameters:
  • end (CurveEnd) – If CurveEnd.Start the function simplifies the last two start side segments, otherwise if CurveEnd.End the last two end side segments are simplified.
  • options (CurveSimplifyOptions) – Simplification options.
  • distanceTolerance (float) – A distance tolerance for the simplification.
  • angleToleranceRadians (float) – An angle tolerance for the simplification.
  • multiple (bool) – (default False) If True, all parameters are expected as lists of equal length and input will be batch processed
Returns:

New simplified curve on success, None on failure.

Return type:

rhino3dm.Curve

compute_rhino3d.Curve.Fair(thisCurve, distanceTolerance, angleTolerance, clampStart, clampEnd, iterations, multiple=False)

Fairs a curve object. Fair works best on degree 3 (cubic) curves. Attempts to remove large curvature variations while limiting the geometry changes to be no more than the specified tolerance.

Parameters:
  • distanceTolerance (float) – Maximum allowed distance the faired curve is allowed to deviate from the input.
  • angleTolerance (float) – (in radians) kinks with angles <= angleTolerance are smoothed out 0.05 is a good default.
  • clampStart (int) – The number of (control vertices-1) to preserve at start. 0 = preserve start point1 = preserve start point and 1st derivative2 = preserve start point, 1st and 2nd derivative
  • clampEnd (int) – Same as clampStart.
  • iterations (int) – The number of iteratoins to use in adjusting the curve.
  • multiple (bool) – (default False) If True, all parameters are expected as lists of equal length and input will be batch processed
Returns:

Returns new faired Curve on success, None on failure.

Return type:

rhino3dm.Curve

compute_rhino3d.Curve.Fit(thisCurve, degree, fitTolerance, angleTolerance, multiple=False)

Fits a new curve through an existing curve.

Parameters:
  • degree (int) – The degree of the returned Curve. Must be bigger than 1.
  • fitTolerance (float) – The fitting tolerance. If fitTolerance is RhinoMath.UnsetValue or <=0.0, the document absolute tolerance is used.
  • angleTolerance (float) – The kink smoothing tolerance in radians. If angleTolerance is 0.0, all kinks are smoothedIf angleTolerance is >0.0, kinks smaller than angleTolerance are smoothedIf angleTolerance is RhinoMath.UnsetValue or <0.0, the document angle tolerance is used for the kink smoothing
  • multiple (bool) – (default False) If True, all parameters are expected as lists of equal length and input will be batch processed
Returns:

Returns a new fitted Curve if successful, None on failure.

Return type:

rhino3dm.Curve

compute_rhino3d.Curve.Rebuild(thisCurve, pointCount, degree, preserveTangents, multiple=False)

Rebuild a curve with a specific point count.

Parameters:
  • pointCount (int) – Number of control points in the rebuild curve.
  • degree (int) – Degree of curve. Valid values are between and including 1 and 11.
  • preserveTangents (bool) – If true, the end tangents of the input curve will be preserved.
  • multiple (bool) – (default False) If True, all parameters are expected as lists of equal length and input will be batch processed
Returns:

A Nurbs curve on success or None on failure.

Return type:

rhino3dm.NurbsCurve

compute_rhino3d.Curve.ToPolyline(thisCurve, mainSegmentCount, subSegmentCount, maxAngleRadians, maxChordLengthRatio, maxAspectRatio, tolerance, minEdgeLength, maxEdgeLength, keepStartPoint, multiple=False)

Gets a polyline approximation of a curve.

Parameters:
  • mainSegmentCount (int) – If mainSegmentCount <= 0, then both subSegmentCount and mainSegmentCount are ignored. If mainSegmentCount > 0, then subSegmentCount must be >= 1. In this case the nurb will be broken into mainSegmentCount equally spaced chords. If needed, each of these chords can be split into as many subSegmentCount sub-parts if the subdivision is necessary for the mesh to meet the other meshing constraints. In particular, if subSegmentCount = 0, then the curve is broken into mainSegmentCount pieces and no further testing is performed.
  • subSegmentCount (int) – An amount of subsegments.
  • maxAngleRadians (float) – ( 0 to pi ) Maximum angle (in radians) between unit tangents at adjacent vertices.
  • maxChordLengthRatio (float) – Maximum permitted value of (distance chord midpoint to curve) / (length of chord).
  • maxAspectRatio (float) – If maxAspectRatio < 1.0, the parameter is ignored. If 1 <= maxAspectRatio < sqrt(2), it is treated as if maxAspectRatio = sqrt(2). This parameter controls the maximum permitted value of (length of longest chord) / (length of shortest chord).
  • tolerance (float) – If tolerance = 0, the parameter is ignored. This parameter controls the maximum permitted value of the distance from the curve to the polyline.
  • minEdgeLength (float) – The minimum permitted edge length.
  • maxEdgeLength (float) – If maxEdgeLength = 0, the parameter is ignored. This parameter controls the maximum permitted edge length.
  • keepStartPoint (bool) – If True the starting point of the curve is added to the polyline. If False the starting point of the curve is not added to the polyline.
  • multiple (bool) – (default False) If True, all parameters are expected as lists of equal length and input will be batch processed
Returns:

PolylineCurve on success, None on error.

Return type:

PolylineCurve

compute_rhino3d.Curve.ToPolyline1(thisCurve, mainSegmentCount, subSegmentCount, maxAngleRadians, maxChordLengthRatio, maxAspectRatio, tolerance, minEdgeLength, maxEdgeLength, keepStartPoint, curveDomain, multiple=False)

Gets a polyline approximation of a curve.

Parameters:
  • mainSegmentCount (int) – If mainSegmentCount <= 0, then both subSegmentCount and mainSegmentCount are ignored. If mainSegmentCount > 0, then subSegmentCount must be >= 1. In this case the nurb will be broken into mainSegmentCount equally spaced chords. If needed, each of these chords can be split into as many subSegmentCount sub-parts if the subdivision is necessary for the mesh to meet the other meshing constraints. In particular, if subSegmentCount = 0, then the curve is broken into mainSegmentCount pieces and no further testing is performed.
  • subSegmentCount (int) – An amount of subsegments.
  • maxAngleRadians (float) – ( 0 to pi ) Maximum angle (in radians) between unit tangents at adjacent vertices.
  • maxChordLengthRatio (float) – Maximum permitted value of (distance chord midpoint to curve) / (length of chord).
  • maxAspectRatio (float) – If maxAspectRatio < 1.0, the parameter is ignored. If 1 <= maxAspectRatio < sqrt(2), it is treated as if maxAspectRatio = sqrt(2). This parameter controls the maximum permitted value of (length of longest chord) / (length of shortest chord).
  • tolerance (float) – If tolerance = 0, the parameter is ignored. This parameter controls the maximum permitted value of the distance from the curve to the polyline.
  • minEdgeLength (float) – The minimum permitted edge length.
  • maxEdgeLength (float) – If maxEdgeLength = 0, the parameter is ignored. This parameter controls the maximum permitted edge length.
  • keepStartPoint (bool) – If True the starting point of the curve is added to the polyline. If False the starting point of the curve is not added to the polyline.
  • curveDomain (rhino3dm.Interval) – This subdomain of the NURBS curve is approximated.
  • multiple (bool) – (default False) If True, all parameters are expected as lists of equal length and input will be batch processed
Returns:

PolylineCurve on success, None on error.

Return type:

PolylineCurve

compute_rhino3d.Curve.ToPolyline2(thisCurve, tolerance, angleTolerance, minimumLength, maximumLength, multiple=False)

Gets a polyline approximation of a curve.

Parameters:
  • tolerance (float) – The tolerance. This is the maximum deviation from line midpoints to the curve. When in doubt, use the document’s model space absolute tolerance.
  • angleTolerance (float) – The angle tolerance in radians. This is the maximum deviation of the line directions. When in doubt, use the document’s model space angle tolerance.
  • minimumLength (float) – The minimum segment length.
  • maximumLength (float) – The maximum segment length.
  • multiple (bool) – (default False) If True, all parameters are expected as lists of equal length and input will be batch processed
Returns:

PolyCurve on success, None on error.

Return type:

PolylineCurve

compute_rhino3d.Curve.ToArcsAndLines(thisCurve, tolerance, angleTolerance, minimumLength, maximumLength, multiple=False)

Converts a curve into polycurve consisting of arc segments. Sections of the input curves that are nearly straight are converted to straight-line segments.

Parameters:
  • tolerance (float) – The tolerance. This is the maximum deviation from arc midpoints to the curve. When in doubt, use the document’s model space absolute tolerance.
  • angleTolerance (float) – The angle tolerance in radians. This is the maximum deviation of the arc end directions from the curve direction. When in doubt, use the document’s model space angle tolerance.
  • minimumLength (float) – The minimum segment length.
  • maximumLength (float) – The maximum segment length.
  • multiple (bool) – (default False) If True, all parameters are expected as lists of equal length and input will be batch processed
Returns:

PolyCurve on success, None on error.

Return type:

PolyCurve

compute_rhino3d.Curve.PullToMesh(thisCurve, mesh, tolerance, multiple=False)

Makes a polyline approximation of the curve and gets the closest point on the mesh for each point on the curve. Then it “connects the points” so that you have a polyline on the mesh.

Parameters:
  • mesh (rhino3dm.Mesh) – Mesh to project onto.
  • tolerance (float) – Input tolerance (RhinoDoc.ModelAbsoluteTolerance is a good default)
  • multiple (bool) – (default False) If True, all parameters are expected as lists of equal length and input will be batch processed
Returns:

A polyline curve on success, None on failure.

Return type:

PolylineCurve

compute_rhino3d.Curve.Offset(thisCurve, plane, distance, tolerance, cornerStyle, multiple=False)

Offsets this curve. If you have a nice offset, then there will be one entry in the array. If the original curve had kinks or the offset curve had self intersections, you will get multiple segments in the offset_curves[] array.

Parameters:
  • plane (rhino3dm.Plane) – Offset solution plane.
  • distance (float) – The positive or negative distance to offset.
  • tolerance (float) – The offset or fitting tolerance.
  • cornerStyle (CurveOffsetCornerStyle) – Corner style for offset kinks.
  • multiple (bool) – (default False) If True, all parameters are expected as lists of equal length and input will be batch processed
Returns:

Offset curves on success, None on failure.

Return type:

rhino3dm.Curve[]

compute_rhino3d.Curve.Offset1(thisCurve, directionPoint, normal, distance, tolerance, cornerStyle, multiple=False)

Offsets this curve. If you have a nice offset, then there will be one entry in the array. If the original curve had kinks or the offset curve had self intersections, you will get multiple segments in the offset_curves[] array.

Parameters:
  • directionPoint (rhino3dm.Point3d) – A point that indicates the direction of the offset.
  • normal (rhino3dm.Vector3d) – The normal to the offset plane.
  • distance (float) – The positive or negative distance to offset.
  • tolerance (float) – The offset or fitting tolerance.
  • cornerStyle (CurveOffsetCornerStyle) – Corner style for offset kinks.
  • multiple (bool) – (default False) If True, all parameters are expected as lists of equal length and input will be batch processed
Returns:

Offset curves on success, None on failure.

Return type:

rhino3dm.Curve[]

compute_rhino3d.Curve.RibbonOffset(thisCurve, distance, blendRadius, directionPoint, normal, tolerance, multiple=False)

Offsets a closed curve in the following way: pProject the curve to a plane with given normal. Then, loose Offset the projection by distance + blend_radius and trim off self-intersection. THen, Offset the remaining curve back in the opposite direction by blend_radius, filling gaps with blends. Finally, use the elevations of the input curve to get the correct elevations of the result.

Parameters:
  • distance (float) – The positive distance to offset the curve.
  • blendRadius (float) – Positive, typically the same as distance. When the offset results in a self-intersection that gets trimmed off at a kink, the kink will be blended out using this radius.
  • directionPoint (rhino3dm.Point3d) – A point that indicates the direction of the offset. If the offset is inward, the point’s projection to the plane should be well within the curve. It will be used to decide which part of the offset to keep if there are self-intersections.
  • normal (rhino3dm.Vector3d) – A vector that indicates the normal of the plane in which the offset will occur.
  • tolerance (float) – Used to determine self-intersections, not offset error.
  • multiple (bool) – (default False) If True, all parameters are expected as lists of equal length and input will be batch processed
Returns:

The offset curve if successful.

Return type:

rhino3dm.Curve

compute_rhino3d.Curve.OffsetOnSurface(thisCurve, face, distance, fittingTolerance, multiple=False)

Offset this curve on a brep face surface. This curve must lie on the surface.

Parameters:
  • face (rhino3dm.BrepFace) – The brep face on which to offset.
  • distance (float) – A distance to offset (+)left, (-)right.
  • fittingTolerance (float) – A fitting tolerance.
  • multiple (bool) – (default False) If True, all parameters are expected as lists of equal length and input will be batch processed
Returns:

Offset curves on success, or None on failure.

Return type:

rhino3dm.Curve[]

compute_rhino3d.Curve.OffsetOnSurface1(thisCurve, face, throughPoint, fittingTolerance, multiple=False)

Offset a curve on a brep face surface. This curve must lie on the surface. This overload allows to specify a surface point at which the offset will pass.

Parameters:
  • face (rhino3dm.BrepFace) – The brep face on which to offset.
  • throughPoint (rhino3dm.Point2d) – 2d point on the brep face to offset through.
  • fittingTolerance (float) – A fitting tolerance.
  • multiple (bool) – (default False) If True, all parameters are expected as lists of equal length and input will be batch processed
Returns:

Offset curves on success, or None on failure.

Return type:

rhino3dm.Curve[]

compute_rhino3d.Curve.OffsetOnSurface2(thisCurve, face, curveParameters, offsetDistances, fittingTolerance, multiple=False)

Offset a curve on a brep face surface. This curve must lie on the surface. This overload allows to specify different offsets for different curve parameters.

Parameters:
  • face (rhino3dm.BrepFace) – The brep face on which to offset.
  • curveParameters (float[]) – Curve parameters corresponding to the offset distances.
  • offsetDistances (float[]) – distances to offset (+)left, (-)right.
  • fittingTolerance (float) – A fitting tolerance.
  • multiple (bool) – (default False) If True, all parameters are expected as lists of equal length and input will be batch processed
Returns:

Offset curves on success, or None on failure.

Return type:

rhino3dm.Curve[]

compute_rhino3d.Curve.OffsetOnSurface3(thisCurve, surface, distance, fittingTolerance, multiple=False)

Offset a curve on a surface. This curve must lie on the surface.

Parameters:
  • surface (rhino3dm.Surface) – A surface on which to offset.
  • distance (float) – A distance to offset (+)left, (-)right.
  • fittingTolerance (float) – A fitting tolerance.
  • multiple (bool) – (default False) If True, all parameters are expected as lists of equal length and input will be batch processed
Returns:

Offset curves on success, or None on failure.

Return type:

rhino3dm.Curve[]

compute_rhino3d.Curve.OffsetOnSurface4(thisCurve, surface, throughPoint, fittingTolerance, multiple=False)

Offset a curve on a surface. This curve must lie on the surface. This overload allows to specify a surface point at which the offset will pass.

Parameters:
  • surface (rhino3dm.Surface) – A surface on which to offset.
  • throughPoint (rhino3dm.Point2d) – 2d point on the brep face to offset through.
  • fittingTolerance (float) – A fitting tolerance.
  • multiple (bool) – (default False) If True, all parameters are expected as lists of equal length and input will be batch processed
Returns:

Offset curves on success, or None on failure.

Return type:

rhino3dm.Curve[]

compute_rhino3d.Curve.OffsetOnSurface5(thisCurve, surface, curveParameters, offsetDistances, fittingTolerance, multiple=False)

Offset this curve on a surface. This curve must lie on the surface. This overload allows to specify different offsets for different curve parameters.

Parameters:
  • surface (rhino3dm.Surface) – A surface on which to offset.
  • curveParameters (float[]) – Curve parameters corresponding to the offset distances.
  • offsetDistances (float[]) – Distances to offset (+)left, (-)right.
  • fittingTolerance (float) – A fitting tolerance.
  • multiple (bool) – (default False) If True, all parameters are expected as lists of equal length and input will be batch processed
Returns:

Offset curves on success, or None on failure.

Return type:

rhino3dm.Curve[]

compute_rhino3d.Curve.PullToBrepFace1(thisCurve, face, tolerance, multiple=False)

Pulls this curve to a brep face and returns the result of that operation.

Parameters:
  • face (rhino3dm.BrepFace) – A brep face.
  • tolerance (float) – A tolerance value.
  • multiple (bool) – (default False) If True, all parameters are expected as lists of equal length and input will be batch processed
Returns:

An array containing the resulting curves after pulling. This array could be empty.

Return type:

rhino3dm.Curve[]

compute_rhino3d.Curve.OffsetNormalToSurface(thisCurve, surface, height, multiple=False)

Finds a curve by offsetting an existing curve normal to a surface. The caller is responsible for ensuring that the curve lies on the input surface.

Parameters:
  • surface (rhino3dm.Surface) – Surface from which normals are calculated.
  • height (float) – offset distance (distance from surface to result curve)
  • multiple (bool) – (default False) If True, all parameters are expected as lists of equal length and input will be batch processed
Returns:

Offset curve at distance height from the surface. The offset curve is interpolated through a small number of points so if the surface is irregular or complicated, the result will not be a very accurate offset.

Return type:

rhino3dm.Curve